
class Cbar:
    def __init__(self):
        pass
    def registerThemeManager(self, themeManager):
        """Registers object themeManager as theme manager.
        Returns connection object which will be used to connect signals.
        """
        import cbarlib 
        import sip
        import qt
        #transfer ownership of object to C++, so that it is not destroyed
        sip.transferto(themeManager, None)
        connectionObjectPtr = cbarlib.registerThemeManager(sip.unwrapinstance(themeManager))
        connectionObject = sip.wrapinstance(connectionObjectPtr, qt.QObject)
        return connectionObject
    def registerScriptLoader(self, scriptLoader):
        """Registers object scriptLoader as script loader.
        Returns connection object which will be used to connect signals.
        """
        import cbarlib 
        import sip
        import qt
        #transfer ownership of object to C++, so that it is not destroyed
        sip.transferto(scriptLoader, None)
        connectionObjectPtr = cbarlib.registerScriptLoader(sip.unwrapinstance(scriptLoader))
        connectionObject = sip.wrapinstance(connectionObjectPtr, qt.QObject)
        return connectionObject
    def addCbarWidget(self, widget, params):
        """Adds widget to Cbar.
        Returns connection object which will be used to connect signals.
        """
        import cbarlib 
        import sip
        import qt
        sip.transferto(widget, None)
        connectionObjectPtr = cbarlib.addCbarWidget(sip.unwrapinstance(widget), params)
        connectionObject = sip.wrapinstance(connectionObjectPtr, qt.QObject)
        return connectionObject
    def executeScript(self, scriptPath):
        """Executes script using Kross scripting engine.
        scriptPath is path to script.
        Returns true if running script succeeded, else false.
        """
        import cbarlib 
        import sip
        import qt
        return cbarlib.executeScript(scriptPath)
    def getCbarName(self):
        """Returns name of CBar instance.
        """
        import cbarlib 
        cbarName = cbarlib.getCbarName()
        return cbarName
