import cbar
import qt
import kio

class EjectMediaWidget(qt.QWidget):
    def __init__( self, *args ):
        apply(qt.QWidget.__init__, (self,) + args )
        layout = qt.QVBoxLayout(self)
        self.button = qt.QPushButton("Eject", self, "button")
        self.layout().addWidget(self.button, 0, qt.Qt.AlignLeft | qt.Qt.AlignTop)
        self.layout().addStretch(1)
        self.button.hide()
        qt.QObject.connect(self.button, qt.SIGNAL("clicked()"), self.eject)
    def itemsSelected(self, items):
        if len(items) == 1:
            selectedItem = items[0]
            if qt.QString(selectedItem.mimetype()).startsWith("media/"):
                self.button.show()
                self.ejectUrl = selectedItem.url().path()
            else:
                self.button.hide()
        else:
            self.button.hide()
    def eject(self):
        import os
        os.system("eject %s" % self.ejectUrl)

widget = EjectMediaWidget()

cbarInterface = cbar.Cbar()

params = { "type": "Actions"}

connectionObject = cbarInterface.addCbarWidget(widget, params)
qt.QObject.connect(
    connectionObject,
    qt.SIGNAL("signalItemsSelected(const KFileItemList &)"),
    widget.itemsSelected
    )
