import cbar
import qt
import kio

class SelectedItemsWidget(qt.QWidget):
    def __init__( self, *args ):
        apply(qt.QWidget.__init__, (self,) + args )
        layout = qt.QVBoxLayout(self)
        self. setMaximumWidth(300)
        self.label = qt.QLabel("", self, "label")
        self.layout().addWidget(self.label, 0, qt.Qt.AlignLeft | qt.Qt.AlignTop)
        self.itemsLabel = qt.QLabel("", self, "label")
        self.layout().addWidget(self.itemsLabel, 0, qt.Qt.AlignLeft | qt.Qt.AlignTop)
    def itemsSelected(self, items):
        if len(items) > 1:
            self.itemsLabel.setText("Items selected: %s\n" % len(items))
            return
        
        s = ""
        for item in items:
            if  item.isLocalFile():
                filename = item.text()
            else:
                filename = item.url().url()
            metaInfo = ""
            
            itemMetaInfo = item.metaInfo()
            if itemMetaInfo.isValid():
                for metaKey in itemMetaInfo.supportedKeys():
                    metaInfo += u"%s: %s\n" % (metaKey, item.metaInfo().item(metaKey).string() )

            s += u"Item: %s\nType: %s\nPermissions:%s\n%s" % (filename, item.mimeComment(), item.permissionsString(), metaInfo)
        self.itemsLabel.setText(s)
    def urlOpened(self, urlString):
        import kdecore
        url = kdecore.KURL(urlString)
        
        if (url.isLocalFile()):
            displayUrl = url.path()
        else:
            displayUrl = url.prettyURL()
        
        self.label.setText(qt.QString("Current folder: ") + displayUrl)
    

widget = SelectedItemsWidget()

cbarInterface = cbar.Cbar()

params = { "type": "File details"}

connectionObject = cbarInterface.addCbarWidget(widget, params)
qt.QObject.connect(
    connectionObject,
    qt.SIGNAL("signalItemsSelected(const KFileItemList &)"),
    widget.itemsSelected
    )
qt.QObject.connect(
    connectionObject, 
    qt.SIGNAL("signalUrlOpened(const QString &)"),
    widget.urlOpened
    )
