/***************************************************************************
  Copyright:
  (C) 2006 Krzysztof Lichota <krzysiek-cbar@lichota.net>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License
 *                                                                         *
 ***************************************************************************/

#include <Python.h>

#include <khtml_part.h> // this plugin applies to a khtml part
#include <kdebug.h>
#include "cbarkonqplugin.h"
#include <klibloader.h>
#include <kgenericfactory.h>
#include <qmessagebox.h>
#include <qdatetime.h>

CbarKonqPlugin::CbarKonqPlugin( QObject* parent, const char* name, const QStringList& )
    : Plugin( parent, name )
{
    const char *preloadCommands = "import qt\nimport kdeui\nimport kio\nimport kdecore\nimport kfile\n";

    kdDebug() << "CbarKonqPlugin loaded\n";
    QTime startTime = QTime::currentTime();
    startTime.start();
    
/*    Py_SetProgramName((char *)"cbar");*/
    if (! Py_IsInitialized())
    {
        Py_Initialize();
    }
    
    kdDebug() << "CbarKonqPlugin::CbarKonqPlugin(): Starting running preload commands: " << preloadCommands 
        << ", start time=" << startTime.toString("hh:mm:ss.zzz")  << " \n";
    
    bool ok = PyRun_SimpleString(preloadCommands);
    
    if (ok == false)
    {
        kdDebug() << "CbarKonqPlugin::CbarKonqPlugin(): Failed to run preload commands: " << preloadCommands << "\n";
    }
    
/*
    QString scriptFileName("/tmp/preload.py");
    FILE *file = fopen(scriptFileName.data(), "r");
    
    if (file == NULL)
    {
        kdDebug() << "Failed to open file " << scriptFileName << ", error=" << errno << " (" << strerror(errno) << ")\n"; //FIXME: remove strerror, it is not thread-safe
        return;
    }
    
    bool ok = PyRun_SimpleFile(file, scriptFileName.data());
    
    fclose(file);*/


    
    QTime endTime = QTime::currentTime();
    kdDebug() << "CbarKonqPlugin::CbarKonqPlugin(): Finished running preload commands: " << preloadCommands
        << ", start time=" << startTime.toString("hh:mm:ss.zzz")
        << ", endTime=" << endTime.toString("hh:mm:ss.zzz")
        << ", duration=" <<  startTime.elapsed() << " ms"
        <<  " \n";
}

CbarKonqPlugin::~CbarKonqPlugin()
{
    kdDebug() << "CbarKonqPlugin destroyed\n";
}

K_EXPORT_COMPONENT_FACTORY( libcbarkonqplugin, KGenericFactory<CbarKonqPlugin>("cbarkonqplugin") )

#include "cbarkonqplugin.moc"
