
#include <qlabel.h>
#include <kinstance.h>
#include <qstring.h>
#include <qwidget.h>
#include <kdebug.h>

#include "cbar.h"
#include "cbar.moc"

CbarSidebar::CbarSidebar(KInstance *inst,QObject *parent,QWidget *widgetParent, QString &desktopName, const char* name):
                   KonqSidebarPlugin(inst,parent,widgetParent,desktopName,name)
{
    widget =  CbarFactory::createCbarWidget("CbarSidebar", widgetParent);
}


CbarSidebar::~CbarSidebar()
{
}

void CbarSidebar::handleURL(const KURL &url)
{
    this->widget->urlOpened(url.url());
}

void CbarSidebar::handlePreview(const KFileItemList & items)
{
    this->widget->itemsSelected(items);
}

extern "C"
{
    void* create_konqsidebar_cbar(KInstance *instance,QObject *par,QWidget *widp,QString &desktopname,const char *name)
    {
        kdDebug() << "create_konqsidebar_cbar called\n";
        return new CbarSidebar(instance,par,widp,desktopname,name);
    }
};

extern "C" {
    bool add_konqsidebar_cbar(QString* fn, QString* param, QMap<QString,QString> *map) 
    {
         Q_UNUSED(param);
     
         map->insert("Type", "Link");
         map->insert("Icon", "folder_favorite");
         map->insert("Name", "CBar Sidebar");
         map->insert("Open", "true");
         map->insert("X-KDE-KonqSidebarModule","konqsidebar_cbar");
         fn->setLatin1("cbarsidebar%1.desktop");
         return true;
    }
};
