#include <klibloader.h>
#include <qfile.h>
#include <kdebug.h>

class KonqSidebarPlugin;

extern "C"
{

void* create_konqsidebar_cbar_loader(
    KInstance *instance,
    QObject *par,
    QWidget *widp,
    QString &desktopname,
    const char *name
    )
{
    //Load real cbar sidebar plugin using globalLibrary, to provide
    //symbols to python libraries loaded later
    //This hack can be removed if Konqueror loads plugins using globalLibrary() 
    //instead of library()
    //Library loading code taken from sidebar_widget.cpp
    const char * lib_name = "konqsidebar_cbar";
    kdDebug() << "CbarSidebar loader - loading real library\n";
    
    KLibLoader *loader = KLibLoader::self();

    // try to load the library
    KLibrary *lib = loader->globalLibrary(QFile::encodeName(lib_name));
    if (lib)
    {
        // get the create_ function
        QString factory("create_%1");
        void *create = lib->symbol(QFile::encodeName(factory.arg(lib_name)));

        if (create)
        {
            // create the module
            KonqSidebarPlugin* (*func)(KInstance*,QObject *, QWidget*, QString&, const char *);
            func = (KonqSidebarPlugin* (*)(KInstance*,QObject *, QWidget *, QString&, const char *)) create;
            return  (KonqSidebarPlugin*)func(instance,par,widp,desktopname,0);
        }
    } else {
        kdWarning() << "Module " << lib_name << " doesn't specify a library!" << endl;
    }
    kdDebug() << "CbarSidebar loader - library loaded\n";
    return 0;
}

bool add_konqsidebar_cbar_loader(QString* fn, QString* param, QMap<QString,QString> *map) 
{
     Q_UNUSED(param);
 
     map->insert("Type", "Link");
     map->insert("Icon", "folder_favorite");
     map->insert("Name", "CBar Sidebar");
     map->insert("Open", "true");
     map->insert("X-KDE-KonqSidebarModule","konqsidebar_cbar_loader");
     fn->setLatin1("cbarsidebar%1.desktop");
     return true;
}


}; //extern "C"
